diff -ur --unidirectional-new-file /usr/src/usr.sbin/inetd/Makefile /usr/src-new/usr.sbin/inetd/Makefile
--- /usr/src/usr.sbin/inetd/Makefile	2004-01-31 00:56:44.000000000 -0600
+++ /usr/src-new/usr.sbin/inetd/Makefile	2006-06-20 11:04:28.000000000 -0500
@@ -1,20 +1,26 @@
-#	@(#)Makefile	8.1 (Berkeley) 6/6/93
-# $FreeBSD: src/usr.sbin/inetd/Makefile,v 1.18.2.4 2001/12/19 04:49:11 dd Exp $
-# $DragonFly: src/usr.sbin/inetd/Makefile,v 1.3 2004/01/31 06:56:44 dillon Exp $
-
-PROG=	inetd
-SRCS=	inetd.c builtins.c
-MAN=	inetd.8
-MLINKS=	inetd.8 inetd.conf.5
+#	from: @(#)Makefile	8.1 (Berkeley) 6/6/93
+#	$NetBSD: Makefile,v 1.20 2005/01/10 02:58:59 lukem Exp $
+
+.include <bsd.own.mk>
+
+WARNS?=	2
+PROG=   inetd
+SRCS=   inetd.c
+MAN=    inetd.8
+MLINKS= inetd.8 inetd.conf.5
 
 CFLAGS+= -DLOGIN_CAP
 #CFLAGS+= -DSANITY_CHECK
 
-DPADD+=	${LIBUTIL} ${LIBWRAP}
-LDADD+=	-lutil -lwrap
+DPADD+= ${LIBUTIL} ${LIBWRAP}
+LDADD+= -lutil -lwrap
 .if !defined(RELEASE_CRUNCH)
 CFLAGS+=-DINET6 -DIPSEC
-DPADD+=	${LIBIPSEC}
-LDADD+=	-lipsec
+DPADD+= ${LIBIPSEC}
+SRCS+=ipsec.c
+LDADD+= -lipsec
 .endif
+
 .include <bsd.prog.mk>
+
+
Only in /usr/src/usr.sbin/inetd/: builtins.c
diff -ur --unidirectional-new-file /usr/src/usr.sbin/inetd/inetd.c /usr/src-new/usr.sbin/inetd/inetd.c
--- /usr/src/usr.sbin/inetd/inetd.c	2006-01-13 14:26:46.000000000 -0600
+++ /usr/src-new/usr.sbin/inetd/inetd.c	2006-06-20 11:11:04.000000000 -0500
@@ -1,3 +1,40 @@
+/*-
+ * Copyright (c) 1998, 2003 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Jason R. Thorpe of the Numerical Aerospace Simulation Facility,
+ * NASA Ames Research Center and by Matthias Scheler.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *	This product includes software developed by the NetBSD
+ *	Foundation, Inc. and its contributors.
+ * 4. Neither the name of The NetBSD Foundation nor the names of its
+ *    contributors may be used to endorse or promote products derived
+ *    from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
 /*
  * Copyright (c) 1983, 1991, 1993, 1994
  *	The Regents of the University of California.  All rights reserved.
@@ -10,11 +47,7 @@
  * 2. Redistributions in binary form must reproduce the above copyright
  *    notice, this list of conditions and the following disclaimer in the
  *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
- * 4. Neither the name of the University nor the names of its contributors
+ * 3. Neither the name of the University nor the names of its contributors
  *    may be used to endorse or promote products derived from this software
  *    without specific prior written permission.
  *
@@ -32,7 +65,7 @@
  *
  * @(#) Copyright (c) 1983, 1991, 1993, 1994 The Regents of the University of California.  All rights reserved.
  * @(#)from: inetd.c	8.4 (Berkeley) 4/13/94
- * $FreeBSD: src/usr.sbin/inetd/inetd.c,v 1.80.2.11 2003/04/05 13:39:18 dwmalone Exp $
+ * $NetBSD: inetd.c,v 1.101 2006/05/11 06:59:40 mrg Exp $
  * $DragonFly: src/usr.sbin/inetd/inetd.c,v 1.10 2006/01/13 20:26:46 swildner Exp $
  */
 
@@ -56,19 +89,51 @@
  * Inetd uses a configuration file which is read at startup
  * and, possibly, at some later time in response to a hangup signal.
  * The configuration file is ``free format'' with fields given in the
- * order shown below.  Continuation lines for an entry must begin with
+ * order shown below.  Continuation lines for an entry must being with
  * a space or tab.  All fields must be present in each entry.
  *
- *	service name			must be in /etc/services
- *					or name a tcpmux service 
- *					or specify a unix domain socket
+ *	service name			must be in /etc/services or must
+ *					name a tcpmux service
+ *	socket type			stream/dgram/raw/rdm/seqpacket
+ *	protocol			must be in /etc/protocols
+ *	wait/nowait[:max]		single-threaded/multi-threaded, max #
+ *	user[:group]			user/group to run daemon as
+ *	server program			full path name
+ *	server program arguments	maximum of MAXARGS (20)
+ *
+ * For RPC services
+ *      service name/version            must be in /etc/rpc
  *	socket type			stream/dgram/raw/rdm/seqpacket
- *	protocol			tcp[4][6][/faith,ttcp], udp[4][6], unix
- *	wait/nowait			single-threaded/multi-threaded
- *	user				user to run daemon as
+ *	protocol			must be in /etc/protocols
+ *	wait/nowait[:max]		single-threaded/multi-threaded
+ *	user[:group]			user to run daemon as
  *	server program			full path name
  *	server program arguments	maximum of MAXARGS (20)
  *
+ * For non-RPC services, the "service name" can be of the form
+ * hostaddress:servicename, in which case the hostaddress is used
+ * as the host portion of the address to listen on.  If hostaddress
+ * consists of a single `*' character, INADDR_ANY is used.
+ *
+ * A line can also consist of just
+ *	hostaddress:
+ * where hostaddress is as in the preceding paragraph.  Such a line must
+ * have no further fields; the specified hostaddress is remembered and
+ * used for all further lines that have no hostaddress specified,
+ * until the next such line (or EOF).  (This is why * is provided to
+ * allow explicit specification of INADDR_ANY.)  A line
+ *	*:
+ * is implicitly in effect at the beginning of the file.
+ *
+ * The hostaddress specifier may (and often will) contain dots;
+ * the service name must not.
+ *
+ * For RPC services, host-address specifiers are accepted and will
+ * work to some extent; however, because of limitations in the
+ * portmapper interface, it will not work to try to give more than
+ * one line for any given RPC service, even if the host-address
+ * specifiers are different.
+ *
  * TCP services without official port numbers are handled with the
  * RFC1078-based tcpmux internal service. Tcpmux listens on port 1 for
  * requests. When a connection is made from a foreign host, the service
@@ -84,15 +149,6 @@
  * because they do not have a well-known port and hence cannot listen
  * for new requests.
  *
- * For RPC services
- *	service name/version		must be in /etc/rpc
- *	socket type			stream/dgram/raw/rdm/seqpacket
- *	protocol			rpc/tcp, rpc/udp
- *	wait/nowait			single-threaded/multi-threaded
- *	user				user to run daemon as
- *	server program			full path name
- *	server program arguments	maximum of MAXARGS
- *
  * Comment lines are indicated by a `#' in column 1.
  *
  * #ifdef IPSEC
@@ -102,6 +158,30 @@
  * there's no IPsec policy.
  * #endif
  */
+
+/*
+ * Here's the scoop concerning the user:group feature:
+ *
+ * 1) set-group-option off.
+ *
+ * 	a) user = root:	NO setuid() or setgid() is done
+ *
+ * 	b) other:	setuid()
+ * 			setgid(primary group as found in passwd)
+ * 			initgroups(name, primary group)
+ *
+ * 2) set-group-option on.
+ *
+ * 	a) user = root:	NO setuid()
+ * 			setgid(specified group)
+ * 			NO initgroups()
+ *
+ * 	b) other:	setuid()
+ * 			setgid(specified group)
+ * 			initgroups(name, specified group)
+ *
+ */
+
 #include <sys/param.h>
 #include <sys/ioctl.h>
 #include <sys/wait.h>
@@ -109,13 +189,17 @@
 #include <sys/resource.h>
 #include <sys/stat.h>
 #include <sys/un.h>
+#include <sys/event.h>
 
-#include <netinet/in.h>
+#include <netinet/in.h>  
 #include <netinet/tcp.h>
+
 #include <arpa/inet.h>
 #include <rpc/rpc.h>
 #include <rpc/pmap_clnt.h>
 
+#include <net/if.h>
+
 #include <errno.h>
 #include <err.h>
 #include <fcntl.h>
@@ -132,22 +216,23 @@
 #include <libutil.h>
 #include <sysexits.h>
 #include <ctype.h>
+#include <ifaddrs.h>
 
-#include "inetd.h"
 #include "pathnames.h"
 
 #ifdef IPSEC
 #include <netinet6/ipsec.h>
-#ifndef IPSEC_POLICY_IPSEC	/* no ipsec support on old ipsec */
+#ifndef IPSEC_POLICY_IPSEC      /* no ipsec support on old ipsec */
 #undef IPSEC
 #endif
 #endif
 
-/* wrapper for KAME-special getnameinfo() */
-#ifndef NI_WITHSCOPEID
-#define NI_WITHSCOPEID	0
+#ifndef RLIMIT_NOFILE
+#define RLIMIT_NOFILE	RLIMIT_OFILE
 #endif
 
+#ifdef LIBWRAP
+# include <tcpd.h>
 #ifndef LIBWRAP_ALLOW_FACILITY
 # define LIBWRAP_ALLOW_FACILITY LOG_AUTH
 #endif
